#!/usr/bin/env python

"""
Parse the USGS Geophraphic Names Information System (GNIS) files and
create an sqlite database.

It is often useful to have place names on maps to get people oriented
to the location of seismic lines.  segy-py might not be the right
place for a gnis module, but where else am I going to put it?

FIX: Turn this into a full blown app that can download the states,
build the database and allow the user to get names suitable for
fledermaus, gmt, and other progra


http://geonames.usgs.gov/stategaz/00README.html
http://geonames.usgs.gov/stategaz/index.html

Hey USGS folks, why not provide a bzip2 version?
http://geonames.usgs.gov/stategaz/CA_DECI.TXT

Pipe (|) separated fields:

Feature ID Number (FID)
State Alpha Code
Feature Name
Feature Type
County Name
State Number Code (FIPS Code)
County Number Code (FIPS Code)
Primary Latitude (DMS)
Primary Longitude (DMS)
Primary Latitude (decimal degrees)
Primary Longitude (decimal degrees)
Source Latitude (DMS)
Source Longitude (DMS)
Source Latitude (decimal degrees)
Source Longitude (decimal degrees)
Elevation
Estimated Population
Federal Status
Cell Name
"""

import sqlite
import os
import sys


if __name__ == "__main__":

    cx = sqlite.connect('ca-names.db') # No, this has nothing to do with DNS!!

    cu = cx.cursor()
    cu.execute('CREATE TABLE places ( name VARCHAR(60), type VARCHAR(50), lon REAL, lat REAL);')
    cx.commit()
    
    count = 0
    for line in open ('CA_DECI.TXT','r').xreadlines():
        count += 1
        if count%500==0: print count
        
        fields = line.split('|')
        name = fields[2]
        if -1 != name.find("'"):
            print 'skipping ',name,
            continue
        type = fields[3]
        try:
            lon = float(fields[10])
            lat = float(fields[9])
        except ValueError:
            print "skipping line (bad lon/lat): ",line,
            continue

        insertStr  = 'INSERT INTO places (name,type,lon,lat) VALUES ('
        insertStr += "'"+name+"'"
        insertStr += ", '"+type+"'"
        insertStr += ', '+str(lon)
        insertStr += ', '+str(lat)
        insertStr += ');'

        cu.execute (insertStr)

    cx.commit()

# FIX: turn this into a function def with a bounding box Would be cool
# to be able to just specify the seismic lines and/or gmt grd file

#"""
#Get the Eel River Basin names
#"""
#import sqlite

# if __name__ == "__main__":
#     cx = sqlite.connect('ca-names.db') # No, this has nothing to do with DNS!!
#     cu = cx.cursor()
#     searchStr  = 'SELECT lon,lat,name,type FROM places WHERE '
#     searchStr += ' lon > -125.0'
#     searchStr += ' AND lon < -123.8' # -123.0'
#     searchStr += ' AND lat > 40.1'   # 39.5'
#     searchStr += ' AND lat < 42'
#     searchStr += ' AND (type="cape" OR type="channel" OR type="stream")'
#     searchStr += ';'
#     cu.execute(searchStr)
#     for row in cu.fetchall():
#         if (-1 != row['name'].find('Stream')) or \
#            -1 != row['name'].find('Creek') or \
#            -1 != row['name'].find('Slough'):
#             print 'skipping ', row['name']
#             continue
#         print row['lon'], row['lat'], (' "'+row['name']+'"')

#['airport','arch','area','bar','basin','bay','beach','bench','bend'
#,'bridge','building','canal','cape','cemetery','channel','church'
#,'civil','cliff','crossing','dam','falls','flat','forest','gap','gut'
#,'harbor','hospital','island','lake','locale','military','mine','oilfield'
#,'park','pillar','plain','po','ppl','range','rapids','reserve','reservoir'
#,'ridge','school','slope','spring','stream','summit','swamp','tower'
#,'trail','tunnel','valley','well','woods']
